{$A-,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+}
{$M 32000,0,655360}

Uses
    Dos     ,
    TpDos   ,
    TpString,
    Strings ,
    ChkErrs ;

Const
     MaxAddr = 1000;
     AnimChars = 10;
     WheelChars : Array[1..AnimChars] Of Char = ( '', '', '+', '', '', '', '', '+', '', '' );
     AnimInterval = 50;

Type
    AddressString = String[15];
    AddressInfoType = Record
                       Address       : AddressString;
                       Busy,
                       NoCarrier,
                       Connect,
                       InCalls       : Word;
                       BytesSent,
                       BytesReceived : LongInt;
                       AverageCPS    : Word;
                       SecOnLine     : LongInt;
                       Name          : PChar;
                      End;
    AllAddrInfoType = Array[1..MaxAddr] Of AddressInfoType;

    HourInfo = Record
               Dialing,
               MailTransfer,
               BBS           : LongInt;
               Days          : Word;
               End;

    EventType = ( Waiting, Dialing, Transfer, BBS, WaitForResponse );

    TimeStr = String[9];

Var
   FilesF,
   ConnectF,
   T           : Text;

   intro,
   temp        : String;

   MainReportFileName,
   FilesReportFileName,
   ConnectReportFileName,
   LogFileName         : PathStr;

   NewSection,
   IgnoreMail,
   TrancateLog,
   CorrectDL   : Boolean;

   StartTrancateLog,
   EndTrancateLog   : Word;

   Hourly      : Array [1..24*6] Of HourInfo;
   Graph       : Array [1..48] Of Record
                                  d1,d2,d3,d4 : Byte;
                                  End;

   LastEvent     : EventType;
   LastEventTime : TimeStr;

{--- Log String Structure ---------------}
   Symbol  : String[2];
   Date    : String[7];
   Time    : TimeStr;
   Bink    : String[5];
   Line    : String[255];
{----------------------------------------}

   StartDate, EndDate : String[7];
   StartTime, EndTime : TimeStr;

   BusyPer, NoCarrierPer, ConnectPer : String[12];

   ConnectAll,
   Connect38400,
   Connect28800,
   Connect21600,
   Connect19200,
   Connect16800,
   Connect14400,
   Connect12000,
   Connect9600,
   Connect4800,
   Connect2400   : Word;
   Baud          : LongInt;

   LastFileReportDate    : String[7];

   Bytes, TotalBSent, TotalBReceived : LongInt;

   SP, SE   : Byte;

   AddrBook : ^AllAddrInfoType;
   CurAddr, NextAddr,
   AllDial,
   CPS, TotalCPS,
   I, J, K,
   TotalDays   : Word;

   TotalDial, TotalBusy,
   TotalNoCarrier, TotalConnect,
   TotalInCalls, TotalSecOnLine : LongInt;

   Sending, Receiving : String;
   BytesSending, BytesReceiving : LongInt;

   AnimCnt : Word;

   L,
   LastDecade : LongInt;

   Store   : String;

   TotalDialing,
   TotalTransfer,
   TotalBBS       : LongInt;

   NewStartLine,
   LogLineNo      : LongInt;

   ConnectFailed,
   IncomingCall   : Boolean;


Procedure ProcessDecade(StartT,EndT:LongInt);
Var
   N  : LongInt;
Begin
   LastDecade := 1 + (StartT Div 600);

   If (LastDecade*600)<=EndT Then
     Begin
     Case LastEvent Of
        Dialing: Inc(Hourly[LastDecade].Dialing,LastDecade*600-StartT);
       Transfer: Inc(Hourly[LastDecade].MailTransfer,LastDecade*600-StartT);
            BBS: Inc(Hourly[LastDecade].BBS,LastDecade*600-StartT);
        End;
     Inc(Hourly[LastDecade].Days);
     Inc(LastDecade);
     End;

   While (LastDecade*600)<=EndT Do
        Begin
        Case LastEvent Of
          Dialing: Inc(Hourly[LastDecade].Dialing,600);
         Transfer: Inc(Hourly[LastDecade].MailTransfer,600);
              BBS: Inc(Hourly[LastDecade].BBS,600);
          End;
        Inc(Hourly[LastDecade].Days);
        Inc(LastDecade);
        End;

   N := EndT - (Pred(LastDecade)*600);
   If N>(EndT-StartT) Then N:=EndT-StartT;

   Case LastEvent Of
      Dialing: Inc(Hourly[LastDecade].Dialing,N);
     Transfer: Inc(Hourly[LastDecade].MailTransfer,N);
          BBS: Inc(Hourly[LastDecade].BBS,N);
      End;
End;

Function Seconds ( Time : TimeStr ): LongInt;
Var
   StartHour, StartMinute, StartSecond : LongInt;
Begin
   StartHour:=(Byte(Time[1])-Byte('0'))*10+(Byte(Time[2])-Byte('0'));
   StartMinute:=(Byte(Time[4])-Byte('0'))*10+(Byte(Time[5])-Byte('0'));
   StartSecond:=(Byte(Time[7])-Byte('0'))*10+(Byte(Time[8])-Byte('0'));
   Seconds := 60*(60*StartHour+StartMinute)+StartSecond;
End;

Procedure ProcessLastEvent;
Var
   StartT, EndT   : LongInt;
Begin
   if LastEvent=Waiting Then Exit;

   StartT:=Seconds(LastEventTime);
   EndT:=Seconds(Time);

   If EndT>=StartT Then ProcessDecade(StartT,EndT)
                   Else
     Begin
     ProcessDecade(StartT,24*60*60);
     ProcessDecade(0,EndT);
     End;
End;

Procedure GetNextLine;
Var
    tt   : String;
    StoreTime,
    PastTime : TimeStr;
    PastDate : String[10];
Begin
  PastTime:=Time;
  PastDate:=Date;
  While Not EOF(T) Do
       Begin
       ReadLn ( T, Symbol, Date, Time, Bink, Line );
       Inc(LogLineNo);
       If LogLineNo>NewStartLine Then NewSection:=TRUE;
       If Bink='BINK ' Then break;
       End;
  if Not EOF(T) Then
    Begin
    Dec(Symbol[0]);
    Dec(Date[0]);
    Dec(Time[0]);
    Dec(Bink[0]);

    If (Time[0]<>#0) And (Time[1]<>#0) Then
      Begin
      EndTime:=Time;
      If StartTime[0]=#0 Then
        StartTime:=Time;
      End;
    If (Date[0]<>#0) And (Date[1]<>#0) Then
      Begin
      EndDate:=Date;
      If StartDate[0]=#0 Then
        StartDate:=Date;
      End;
    End
                Else
    Begin
    Symbol:='';
    Date:='';
    Time:='';
    Bink:='';
    Line:='';
    End;

   If (Seconds(PastTime)>Seconds(Time)) And (PastDate=Date) Then
     Begin
     If Abs(60*60*24-Seconds(PastTime)-Seconds(Time))<60*60 Then
       Begin
       WriteLn ( #13, 'Date not changed at midnight at line #', LogLineNo, ', corrected' );
       End
     Else
       Begin
       Write(#13);
       If Abs(Seconds(PastTime)-Seconds(Time))>3 Then
         WriteLn ( #13, 'Time overlap at line #', LogLineNo, ', corrected' );
       StoreTime:=Time;
       Time:=PastTime;
       ProcessLastEvent;
       LastEvent:=Waiting;
       Time:=StoreTime;
       End;
     Write ( 'Reading log: ', LogFileName, ' ' );
     End;

  If LastEvent=WaitForResponse Then
    Begin
    If StUpCase(Copy(Line,1,8))='SPAWNING' Then LastEvent:=BBS
    Else If StUpCase(Copy(Line,1,6))='INTRO:' Then LastEvent:=WaitForResponse
    Else If StUpCase(Copy(Line,1,5))='ADDON' Then LastEvent:=WaitForResponse
    Else If StUpCase(Copy(Line,1,10))='CRC **EMSI' Then LastEvent:=WaitForResponse
    Else If StUpCase(Copy(Line,1,7))='INVALID' Then LastEvent:=WaitForResponse
    Else If Pos(' - low space on ',Line)<>0 Then LastEvent:=WaitForResponse
    Else Begin
         tt:=Trim(Line);
         if tt[Length(tt)]=')' Then LastEvent:=Transfer
                               Else LastEvent:=Waiting;
         End;
    End Else
  If StUpCase(Copy(Line,1,7))='DIALING' Then
    Begin
    ProcessLastEvent;
    LastEvent:=Dialing;
    LastEventTime:=Time;
    End Else
  If StUpCase(Copy(Line,1,7))='CONNECT' Then
    Begin
    ProcessLastEvent;
    LastEvent:=WaitForResponse;
    LastEventTime:=Time;
    End Else
  If (LastEvent=Dialing) Or (LastEvent=BBS) Then
    Begin
    ProcessLastEvent;
    LastEvent:=Waiting;
    End Else
  If (LastEvent=Transfer) And
     ( (StUpCase(Copy(Line,1,6))='END OF') Or
       (StUpCase(Copy(Line,1,4))='BUSY') Or
       (StUpCase(Copy(Line,1,10))='NO CARRIER') Or
       (StUpCase(Copy(Line,1,4))='RING') ) Then
    Begin
    ProcessLastEvent;
    LastEvent:=Waiting;
    End;

  Inc(AnimCnt);
  If (AnimCnt Mod AnimInterval)=0 Then
    Write ( WheelChars[AnimCnt Div AnimInterval], #8 );
  If AnimCnt>AnimChars*AnimInterval Then AnimCnt:=0;
End;

Procedure ProcessCPS;
Begin
   SP := Pos('(',Copy(Line,5,255));
   SE := Pos(' ',Copy(Line,5+SP,255));
   If SE=0 Then SE:=255;
   temp := Trim(Copy ( Line, 5+SP, SE-1 ));
   Val ( temp, Bytes, k );
   If Bytes=0 Then Bytes:=1;
   temp := Trim(Copy ( Line, 5, SP-1 ));
   Val ( temp, CPS, k );
   With AddrBook^[CurAddr] Do
       AverageCPS := Round ( (1.0*Bytes*CPS + 1.0*(BytesSent+BytesReceived)*AverageCPS) /
                             (Bytes+BytesSent+BytesReceived) );
End;

Procedure ProcessConnectString;
Begin
   If StUpCase(Copy(Line,1,7))='CONNECT' Then
     Begin
     Inc(AddrBook^[CurAddr].Connect);
     Temp:=Copy(Line,9,255);
     j:=Pos('/',Temp);
     If j=0 Then Val(Temp,Baud,K)
            Else Val(Copy(Temp,1,j-1),Baud,K);
     If Baud>=38400 Then Inc(Connect38400)
     Else If Baud>=28800 Then Inc(Connect28800)
     Else If Baud>=21600 Then Inc(Connect21600)
     Else If Baud>=19200 Then Inc(Connect19200)
     Else If Baud>=16800 Then Inc(Connect16800)
     Else If Baud>=14400 Then Inc(Connect14400)
     Else If Baud>=12000 Then Inc(Connect12000)
     Else If Baud>=9600 Then Inc(Connect9600)
     Else If Baud>=4800 Then Inc(Connect4800)
     Else If Baud>=2400 Then Inc(Connect2400)
     End;
End;

Procedure FindAddress(temp,intro:string);
Var
   tempforcopy : Array [0..255] Of Char;
Begin
   CurAddr:=NextAddr;
   For i:=2 To NextAddr-1 Do
      If StUpCase(temp)=StUpCase(AddrBook^[i].Address) Then
        Begin
        CurAddr:=i;
        Break;
        End;
   If CurAddr=NextAddr Then
     Begin
     If NextAddr=MaxAddr Then Error('Too many different network addresses...' );
     Inc(NextAddr);
     AddrBook^[CurAddr].Address:=temp;
     AddrBook^[CurAddr].Name:=NIL;
     End;
   If (Intro<>'') And (AddrBook^[CurAddr].Name=NIL) Then
     Begin
     If MaxAvail<(Length(Intro)+16) Then Error ('Not enough memory');
     AddrBook^[CurAddr].Name := StrNew(StrPCopy(tempforcopy,Intro));
     End;
End;

Procedure ReadConfig;
Var
   S, ST  : String;
   N      : Byte;
   LineNo : Word;
   K      : Integer;

   Procedure Err(Msg:String);
   Var SS : String[8];
   Begin
     Str(LineNo,SS);
     ErrorS('Error at line #'+SS+': '+Msg);
   End;

Begin
   Assign ( T, 'BINKSPY.CFG' );
   {$I-} Reset(T);
   {$I+} CheckIOError ( 'Fatal situation: Can not find BINKSPY.CFG.' );
   LineNo:=0;
   While Not EOF(T) Do
        Begin
        Inc(LineNo);
        ReadLn(T,S);
        S:=StUpCase(Trim(S));
        N:=Pos(';',S);
        If N>0 Then S[0]:=Char(Pred(N));
        S:=Trim(S);
        If S[0]=#0 Then Continue;
        If StUpCase(Copy(S,1,7))='BINKLOG' Then
          LogFileName:=Trim(StUpCase(Copy(S,8,255)))
        Else
        If StUpCase(Copy(S,1,17))='PROCESSDLCOUNTERS' Then
          Begin
          ST:=Trim(StUpCase(Copy(S,18,255)));
          If ST='YES' Then CorrectDL:=TRUE
          Else If ST='NO' Then CorrectDL:=FALSE
          Else Err( 'YES or NO expected' );
          End
        Else
        If StUpCase(Copy(S,1,11))='TRUNCATELOG' Then
          Begin
          TrancateLog:=TRUE;
          ST:=Trim(StUpCase(Copy(S,12,255)));
          N:=Pos(' ',ST);
          if N=0 Then N:=Pos(',',ST);
          If N=0 Then Err('Two numbers expected');
          ST:=Trim(Copy(ST,1,N-1));
          Val(ST,StartTrancateLog,K);
          If K<>0 Then Err('Two numbers expected');
          ST:=Trim(Copy(S,13+N,255));
          Val(ST,EndTrancateLog,K);
          If K<>0 Then Err('Two numbers expected');
          End
        Else
        If StUpCase(Copy(S,1,10))='IGNOREMAIL' Then
          Begin
          ST:=Trim(StUpCase(Copy(S,11,255)));
          If ST='YES' Then IgnoreMail:=TRUE
          Else If ST='NO' Then IgnoreMail:=FALSE
          Else Err( 'YES or NO expected' );
          End
        Else
        If StUpCase(Copy(S,1,10))='MAINREPORT' Then
          MainReportFileName:=Trim(StUpCase(Copy(S,11,255)))
        Else
        If StUpCase(Copy(S,1,11))='FILESREPORT' Then
          FilesReportFileName:=Trim(StUpCase(Copy(S,12,255)))
        Else
        If StUpCase(Copy(S,1,13))='CONNECTREPORT' Then
          ConnectReportFileName:=Trim(StUpCase(Copy(S,14,255)))
        Else
        Err ( 'Unknown keyword '''+S+'''' );
        End;
   Close ( T );
End;

Procedure ReportFiles ( FileName, Msg : String );
Var
    Ext : String[4];
Begin
   If IgnoreMail And
      (Length(FileName)>4) And (FileName[Length(FileName)-3]='.') Then
     Begin
     Ext:=StUpCase(Copy(FileName,Length(FileName)-2,3));
     If Ext='PKT' Then Exit;
     If Ext='REQ' Then Exit;
     If Ext[3] In ['0'..'9'] Then
       Begin
       If (Ext[1]='M') And (Ext[2]='O') Then Exit;
       If (Ext[1]='T') And (Ext[2]='U') Then Exit;
       If (Ext[1]='W') And (Ext[2]='E') Then Exit;
       If (Ext[1]='T') And (Ext[2]='H') Then Exit;
       If (Ext[1]='F') And (Ext[2]='R') Then Exit;
       If (Ext[1]='S') And (Ext[2]='A') Then Exit;
       If (Ext[1]='S') And (Ext[2]='U') Then Exit;
       End;
     End;
 { Mail = files with .PKT .REQ .MO? .TU? .WE? .TH? .FR? .SA? .SU? extentions }

   If StUpCase(LastFileReportDate)<>StUpCase(Date) Then
     Begin
     LastFileReportDate:=Date;
     if FilesReportFileName[0]<>#0 Then
       WriteLn(FilesF, '--- ', Date, ' ----------------------------------------------------------------' );
     End;
   if FilesReportFileName[0]<>#0 Then
     WriteLn ( FilesF, Time, ' ', AddrBook^[CurAddr].Address, ' '#9, Msg, #9, FileName );
End;

Procedure MarkLog;
const
  Month : Array [1..12] of String[4] = ( 'Jan','Feb','Mar','Apr','May','Jun',
                                         'Jul','Aug','Sep','Oct','Nov','Dec' );
Var
  y, m, d, dow,
  h, min, s, hund : Word;

    Function LeadingZero(w : Word) : String;
    Var
      s : String;
    Begin
      Str(w:0,s);
      if Length(s) = 1 then
        s := '0' + s;
      LeadingZero := s;
    End;

Begin
   Assign(T,LogFileName);
   {$I-} Append(T);
   {$I+} CheckIOErrorS('Can not open '+LogFileName);
   GetDate(y,m,d,dow);
   GetTime(h,min,s,hund);
   WriteLn(T,' ', d:3, Month[m]:4, ' ',
             LeadingZero(h),':',LeadingZero(min),':',LeadingZero(s),
             ' BINKSPY Log processed successfully' );
   Close(T);
End;

Procedure ScanLog;
Var
   S1          : String[18];
   S2          : String;
   CurLineNo   : LongInt;
   TT          : Text;
   FF          : File;
   Repack      : Boolean;
   OldFileSize,
   N           : LongInt;
Begin
   Assign(FF,LogFileName);
   {$I-} Reset(FF,1);
   {$I+} CheckIOErrorS('Can not open '+LogFileName);
   OldFileSize := FileSize(FF) Div 1024;
   Close(FF);
   Repack:=(OldFileSize>StartTrancateLog);

   NewStartLine:=0;
   Assign(T,LogFileName);
   {$I-} Reset(T);
   {$I+} CheckIOErrorS('Can not open '+LogFileName);
   If Repack Then
     Begin
     Write ( 'Scanning and truncating log file...' );
     Assign(TT,AddbackSlash(JustPathName(LogFileName))+'BINK_LOG.$$$');
     {$I-} Rewrite(TT);
     {$I+} CheckIOErrorS('Can not create BINK_LOG.$$$' );
     N:=0;
     While (N Div 1024)<(OldFileSize-EndTrancateLog) Do
          Begin
          ReadLn(T,S2);
          Inc(N,Length(S2)+2);
          End;
     Repeat
          ReadLn(T,S1,S2);
     Until (StUpCase(Copy(S2,1,11))='BINK BEGIN,') Or
           (StUpCase(Copy(S2,1,12))='BINK DIALING') Or
           (StUpCase(Copy(S2,1,9))='BINK RING');
     WriteLn (TT,S1,S2);
     End
             Else Write ( 'Scanning log file...' );

   CurLineNo:=0;
   While Not EOF(T) Do
        Begin
        Inc(CurLineNo);
        ReadLn(T,S1,S2);
        If Repack Then Begin
          {$I-} WriteLn(TT,S1,S2);
          {$I+} If IOResult<>0 Then
                  Begin
                  Close(T);
                  Close(TT);
                  {$I-} Erase(TT);
                  {$I+} N:=IOResult;
                  Error( 'Error repacking log (disk full?). '#10#13'Do something and retry or disable truncating.' );
                  End;
          End;
        If S2='BINKSPY Log processed successfully' Then
          NewStartLine:=CurLineNo;
        End;
   Close(T);
   If Repack Then
     Begin
     Close(TT);
     {$I-} Erase(T);
     {$I+} N:=IOResult;
     {$I-} Rename(TT,LogFileName);
     {$I+} N:=IOResult;
     End;
   WriteLn ( ' Ok' );
End;

Procedure FileRequest ( FileName : String );
Var
   Name    : String[13];
   Path    : PathStr;
   S       : String;
   Cnt     : String[5];
   P, O, T : Text;
   PS, PE,
   N, c, i : Integer;
Begin
  Name:=JustFileName(FileName);
  Path:=AddBackSlash(JustPathName(FileName));
  Assign(P,Path+'FILES.BBS');
  {$I-} Reset(P);
  {$I+} If IOResult<>0 Then Exit;
  Assign(O,Path+'FILES.$$$');
  {$I-} Rewrite(O);
  {$I+} If IOResult<>0 Then Exit;
  While Not EOF(P) Do
       Begin
       ReadLn(P,S);
       If StUpCase(Name)=StUpCase(Copy(S,1,Length(Name))) Then
         Begin
         PS:=Pos('[', S);
         PE:=Pos(']', S);
         If ((PE-PS)>1) And ((PE-PS)<=5) Then
           Begin
           Cnt:=Copy(S,PS+1,PE-PS-1);
           Val(Cnt,N,c);
           If c=0 Then
             Begin
             Inc(N);
             Str(N:PE-PS-1,Cnt);
             For i:=PS+1 To PE-1 Do
                if Cnt[i-PS]=' ' Then S[i]:='0'
                                 Else S[i]:=Cnt[i-PS];
             End;
           End;
         End;
       WriteLn(O,S);
       End;
  Close(O);
  Close(P);
  Assign(T,Path+'FILES.BAK' );
  {$I-} Erase(T);
  {$I+} i:=IOResult;
  {$I-} Rename(P,Path+'FILES.BAK');
  {$I+} i:=IOResult;
  {$I-} Rename(O,Path+'FILES.BBS');
  {$I+} i:=IOResult;
End;

Function Greater ( Addr1, Addr2 : AddressString ) : Boolean;
Var
   SP, SE,
   V1, V2, k : Integer;
   S         : AddressString;
Begin
   If Addr1=Addr2 Then Begin Greater := FALSE; Exit; End;

   If Not (Addr1[1] In ['0'..'9']) And (Addr2[1] In ['0'..'9']) Then
     Begin Greater := FALSE; Exit; End;
   If (Addr1[1] In ['0'..'9']) And Not (Addr2[1] In ['0'..'9']) Then
     Begin Greater := TRUE; Exit; End;
   If Not (Addr1[1] In ['0'..'9']) And Not (Addr2[1] In ['0'..'9']) Then
     Begin Greater := (Addr1>Addr2); Exit; End;
   If Addr1[1]<>Addr2[1] Then
     Begin Greater := (Addr1[1]>Addr2[1]); Exit; End;

   SP:=Pos(':',Addr1);
   If SP=0 Then Begin Greater := TRUE; Exit; End;
   SE:=Pos('/',Addr1);
   If SE=0 Then Begin Greater := TRUE; Exit; End;
   S:=Copy(Addr1,SP+1,SE-SP-1);
   Val(S,V1,k);
   If k<>0 Then Begin Greater := FALSE; Exit; End;

   SP:=Pos(':',Addr2);
   If SP=0 Then Begin Greater := FALSE; Exit; End;
   SE:=Pos('/',Addr2);
   If SE=0 Then Begin Greater := FALSE; Exit; End;
   S:=Copy(Addr2,SP+1,SE-SP-1);
   Val(S,V2,k);
   If k<>0 Then Begin Greater := TRUE; Exit; End;

   If V1<>V2 Then
     Begin Greater := (V1>V2); Exit; End;

   SP:=Pos('/',Addr1);
   SE:=Pos('.',Addr1);
   If SE=0 Then SE:=Length(Addr1)+1;
   S:=Copy(Addr1,SP+1,SE-SP-1);
   Val(S,V1,k);
   If k<>0 Then Begin Greater := FALSE; Exit; End;

   SP:=Pos('/',Addr2);
   SE:=Pos('.',Addr2);
   If SE=0 Then SE:=Length(Addr2)+1;
   S:=Copy(Addr2,SP+1,SE-SP-1);
   Val(S,V2,k);
   If k<>0 Then Begin Greater := TRUE; Exit; End;

   If V1<>V2 Then
     Begin Greater := (V1>V2); Exit; End;

   SP:=Pos('.',Addr1);
   If SE=0 Then Begin Greater := FALSE; Exit; End;
   S:=Copy(Addr1,SP+1,255);
   Val(S,V1,k);
   If k<>0 Then Begin Greater := FALSE; Exit; End;

   SP:=Pos('.',Addr2);
   If SE=0 Then Begin Greater := TRUE; Exit; End;
   S:=Copy(Addr2,SP+1,255);
   Val(S,V2,k);
   If k<>0 Then Begin Greater := TRUE; Exit; End;

   Greater := (V1>V2);
End;


Procedure SortAddressBook;
Var
   W : AddressInfoType;
   X : AddressString;

   Procedure QuickSort ( L, R : Integer ) ;
   Var
      I, J : Integer;
   Begin
     If Succ(L)>=R Then
         Begin
         If Greater( AddrBook^[L].Address, AddrBook^[R].Address) Then
             Begin
             W := AddrBook^[L];
             AddrBook^[L] := AddrBook^[R] ;
             AddrBook^[R] := W ;
             End ;
         End
                       Else
        Begin
        I := L ;
        J := R ;
        X := AddrBook^[(L+R) ShR 1].Address;
        Repeat
           While (AddrBook^[I].Address<>X) And Not Greater ( AddrBook^[I].Address, X ) Do Inc ( I ) ;
           While     Greater ( AddrBook^[J].Address, X ) Do Dec ( J ) ;
           If I <= J Then
               Begin
               W := AddrBook^[J];
               AddrBook^[J] := AddrBook^[I];
               AddrBook^[I] := W ;
               Inc ( I ) ;
               Dec ( J ) ;
               End ;
        Until I > J ;
        If J > L Then QuickSort ( L , J ) ;
        If I < R Then QuickSort ( I , R ) ;
        End ;
   End ;

Begin
   Write ( 'Sorting...' );
   QuickSort(1,NextAddr-1);
   WriteLn ( ' Ok' );
End ;

Procedure Initialize;
Begin
   If MaxAvail<SizeOf(AddrBook^) Then Error ( 'Not enough memory...' );
   New(AddrBook);
   FillChar(AddrBook^,SizeOf(AddrBook^),0);
   AddrBook^[1].Address:='Unknown';
   NextAddr:=2;

   FillChar(Hourly,sizeof(Hourly),0);

   NewSection := FALSE;
   IgnoreMail := FALSE;
   TrancateLog := FALSE;
   CorrectDL := FALSE;
   AnimCnt := 0;

   LogLineNo:=0;
   NewStartLine:=$7FFFFFFF;

   StartDate:=''; EndDate:='';
   StartTime:=''; EndTime:='';

   LastEvent:=Waiting;
   LastEventTime:='';
   LastDecade:=0;

   LastFileReportDate:='';

   Connect38400:=0;
   Connect28800:=0;
   Connect21600:=0;
   Connect19200:=0;
   Connect16800:=0;
   Connect14400:=0;
   Connect12000:=0;
   Connect9600:=0;
   Connect4800:=0;
   Connect2400:=0;

   MainReportFileName:='';
   FilesReportFileName:='';
   ConnectReportFileName:='';
   LogFileName:='';

   StartTrancateLog:=$7FFF;
   EndTrancateLog:=$7FFF;

   IncomingCall:=FALSE;
End;

Begin
   WriteLn;
   WriteLn ( ' -= Bink/+ Spy =- log assistant v1.4' );
   WriteLn ( 'Coded by WindWalker (c)1994, St.Petersburg' );
   WriteLn;

   Initialize;

   ReadConfig;
   WriteLn ( 'Config read.' );

   If LogFileName='' Then Error ( 'Don''t know where to find log file...' );
   If Not ExistFile(LogFileName) Then Error ( 'Log file missing...' );

   ScanLog;

   if FilesReportFileName[0]<>#0 Then
     Begin
     Assign ( FilesF, FilesReportFileName );
     {$I-} Rewrite ( FilesF );
     {$I+} CheckIOErrorS ( 'Can not create '+FilesReportFileName );
     End;

   If ConnectReportFileName[0]<>#0 Then
     Begin
     Assign ( ConnectF, ConnectReportFileName );
     {$I-} Rewrite ( ConnectF );
     {$I+} CheckIOErrorS ( 'Can not create '+ConnectReportFileName );
     End;

   Write ( 'Reading log: ', LogFileName, ' ' );
   Assign ( T, LogFileName );
   {$I-} Reset ( T );
   {$I+} CheckIOErrorS ( 'Can not open '+LogFileName );
   CurAddr:=1;
   Sending[0]:=#0;
   Receiving[0]:=#0;
   While Not EOF(T) Do
        Begin
        GetNextLine;
        If Bink='BINK' Then
          Begin

   {---------- "Dialing xxx-xxxx (x:xxxx/xxx.xx@domain)" ---------------}
          If StUpCase(Copy(Line,1,7))='DIALING' Then
            Begin
            SP := Pos('(',Copy(Line,8,255));
            SE := Pos('@',Copy(Line,8+SP,255));
            If SE=0 Then SE := Pos(')',Copy(Line,8+SP,255));
            If (SP=0) Or (SE=0) Then CurAddr:=1
                                Else
              Begin
              temp := Copy ( Line, 8+SP, SE-1 );
              FindAddress(temp,'');
              End;

            IncomingCall:=FALSE;
            Sending[0]:=#0;
            Receiving[0]:=#0;
            End Else

{---------- "CPS: xxxx (xxxxxxx bytes)  Efficiency: xxx%" ---------------}
          If StUpCase(Copy(Line,1,4))='CPS:' Then
            Begin
            ProcessCPS;
            End Else

{---------- "Sent-xxx drive:path\filename.ext" --------------------------}
          If StUpCase(Copy(Line,1,4))='SENT' Then
            Begin
            SP := Pos(' ',Copy(Line,5,255));
            temp := Trim(Copy ( Line, 5+SP, 255 ));
            {** temp = filename sent **}
            If StUpCase(temp)=Sending Then
              Begin
              Inc ( AddrBook^[CurAddr].BytesSent, BytesSending );
              ReportFiles ( temp, 'Sent       ' );
              If CorrectDL And NewSection Then FileRequest(Sending);
              End;
            Sending[0]:=#0;
            End Else

{---------- "Received-xxx drive:path\filename.ext" ----------------------}
          If StUpCase(Copy(Line,1,9))='RECEIVED-' Then
            Begin
            SP := Pos(' ',Copy(Line,9,255));
            temp := Trim(Copy ( Line, 9+SP, 255 ));
            {** temp = received filename **}
            If StUpCase(Copy(temp,Length(temp)-Length(Receiving)+1,Length(Receiving)))=Receiving Then
              Begin
              Inc ( AddrBook^[CurAddr].BytesReceived, BytesReceiving );
              ReportFiles ( Receiving, 'Received  ' );
              End;
            Receiving[0]:=#0;
            End Else

{---------- "Saving Partial drive:path\filename.ext" ---------------------}
          If StUpCase(Copy(Line,1,14))='SAVING PARTIAL' Then
            Begin
            SP := Pos(' ',Copy(Line,15,255));
            temp := Trim(Copy ( Line, 15+SP, 255 ));
            {** temp = partially received filename **}
            If Pos(' ',temp)>0 Then temp[0]:=Char(Pos(' ',temp)-1);
            If StUpCase(Copy(temp,Length(temp)-Length(Receiving)+1,Length(Receiving)))=Receiving Then
              ReportFiles ( Receiving, 'Partial receiv.' );
            Receiving[0]:=#0;
            End Else

{---------- "Session aborted" ----------------------------------------------}
          If StUpCase(Copy(Line,1,15))='SESSION ABORTED' Then
            Begin
            If Sending[0]<>#0 Then
              Begin
              ReportFiles ( Sending, 'Partial sent' );
              Sending[0]:=#0;
              End;
            CurAddr:=1;
            End Else

{---------- "Refusing drive:path\filename.ext" ---------------------------}
          If StUpCase(Copy(Line,1,8))='REFUSING' Then
            Begin
            temp := Trim(Copy ( Line, 9, 255 ));
            {** temp = refused filename **}
            If StUpCase(Copy(temp,Length(temp)-Length(Receiving)+1,Length(Receiving)))=Receiving Then
              Begin
              ReportFiles ( Receiving, 'We refused ' );
              End;
            Receiving[0]:=#0;
            End Else

{---------- "Remote refused drive:path\filename.ext" --------------------}
          If StUpCase(Copy(Line,1,14))='REMOTE REFUSED' Then
            Begin
            temp := Trim(Copy(Line, 15, 255 ));
            {** temp = filename sent **}
            If StUpCase(temp)=Sending Then
              Begin
              ReportFiles ( temp, 'Remote refused' );
              { If CorrectDL And NewSection Then FileRequest(Sending); }
              End;
            Sending[0]:=#0;
            End Else

{---------- "Sending drive:path\filename.ext (xxxxxb)" ---------------------}
          If (StUpCase(Copy(Line,1,7))='SENDING') And
             (StUpCase(Copy(Line,9,11))<>'FROM OFFSET') Then
            Begin
            SP := Pos('(',Copy(Line,8,255));
            SE := Pos('b)',Copy(Line,8+SP,255));
            Sending := StUpCase(Trim(Copy(Line,8,SP-1)));
            temp := Copy ( Line, 8+SP, SE-1 );
            Val ( temp, BytesSending, k);
            End Else

{---------- "Receiving drive:path\filename.ext (xxxxxb)" -------------------}
          If StUpCase(Copy(Line,1,9))='RECEIVING' Then
            Begin
            SP := Pos('(',Copy(Line,10,255));
            SE := Pos('b)',Copy(Line,10+SP,255));
            Receiving := StUpCase(Trim(Copy(Line,10,SP-1)));
            temp := Copy ( Line, 10+SP, SE-1 );
            Val ( temp, BytesReceiving, k);
            End Else

{-- "Session with x:xxxx/xxx.xx@fidonet.org Time: xx:xx:xx Cost: $xx.xx"---}
          If StUpCase(Copy(Line,1,12))='SESSION WITH' Then
            Begin
            SE := Pos('@',Copy(Line,14,255));
            If SE=0 Then SE := Pos('Time:',Copy(Line,14,255));
            temp := Copy(Line, 14, SE-1 );
            k:=1;
            For i:=2 To NextAddr-1 Do
               If StUpCase(temp)=StUpCase(AddrBook^[i].Address) Then
                 Begin
                 k:=i;
                 Break;
                 End;
            SP := 6+Pos('Time:',Line);
            SE := Pos('Cost:',Line)-1;
            temp:=Copy(Line,SP,SE-SP);
            Inc(AddrBook^[k].SecOnLine,Seconds(temp));
            CurAddr:=1;
            End Else

{---------- "Ring" ---------------------------------------------------------}
{------- or "Incoming call, dial aborted" ----------------------------------}
          If (StUpCase(Copy(Line,1,4))='RING') Or
             (StUpCase(Copy(Line,1,27))='INCOMING CALL, DIAL ABORTED') Then
            Begin
            Sending[0]:=#0;
            Receiving[0]:=#0;
            IncomingCall:=TRUE;
            CurAddr:=1;
            End Else

{---------- "Connect xxxxxx/xxx/xxx/xxx " ----------------------------------}
          If StUpCase(Copy(Line,1,7))='CONNECT' Then
            Begin
            Store:=Line;
            ConnectFailed:=FALSE;
            Repeat
                 GetNextLine;
                 ConnectFailed := (StUpCase(Copy(Line,1,7))='DIALING') Or
                                  (StUpCase(Copy(Line,1,10))='NO CARRIER') Or
                                  (StUpCase(Copy(Line,1,12))='LOST CARRIER');
            Until ( (StUpCase(Copy(Line,1,6))<>'INTRO:')      And
                    (StUpCase(Copy(Line,1,5))<>'ADDON')       And
                    (StUpCase(Copy(Line,1,10))<>'CRC **EMSI') And
                    (StUpCase(Copy(Line,1,7))<>'INVALID')     And
                    (Pos ( '- low space on ',Line)=0)          ) Or ConnectFailed;
            If Not ConnectFailed Then
              Begin
              temp:=Trim(Line);
              If temp[Length(temp)]=')' Then
                Begin
                k:=0;
                While Pos ( '(', temp )<>0 Do
                     Begin
                     k := k + Pos( '(', temp );
                     temp := Copy ( temp, Pos('(',temp)+1, 255 );
                     End;
                if k=0 Then k:=1;
                SE := Pos('@',temp);
                If SE=0 Then SE := Pos(')',temp);
                intro := Trim(Copy(Trim(Line),1,k-1));
                temp := Copy ( temp, 1, SE-1 );
                FindAddress(temp,intro);
                Line:=Store;
                If StUpCase(Copy(Line,1,7))='CONNECT' Then
                  Begin
                  ProcessConnectString;
                  If IncomingCall Then
                    Begin
                    Dec(AddrBook^[CurAddr].Connect);
                    Inc(AddrBook^[CurAddr].InCalls);
                    End;
                  End;
                If NewSection And (ConnectReportFileName[0]<>#0) Then
                  Begin
                  Write ( ConnectF, Date, ' ', Time, ' ', Baud:6, ' ' );
                  If IncomingCall Then Write ( ConnectF, 'In  ' )
                                  Else Write ( ConnectF, 'Out ' );
                  WriteLn ( ConnectF, Pad(AddrBook^[CurAddr].Address,14), ' ',
                                      AddrBook^[CurAddr].Name );
                  End;
                End;
              End;
            End Else


{---------- "Busy" ---------------------------------------------------------}
          If StUpCase(Copy(Line,1,4))='BUSY' Then
            Begin
            Inc(AddrBook^[CurAddr].Busy);
            CurAddr:=1;
          End Else

{---------- "No carrier" ---------------------------------------------------}
          If StUpCase(Copy(Line,1,10))='NO CARRIER' Then
            Begin
            Inc(AddrBook^[CurAddr].NoCarrier);
            CurAddr:=1;
            End

          End;
        End;
   WriteLn ( ' ' );
   Close(T);
   if FilesReportFileName[0]<>#0 Then
     Begin
     WriteLn ( 'Writing out files report file '+FilesReportFileName+'...' );
     Close(FilesF);
     End;

   If ConnectReportFileName[0]<>#0 Then
     Begin
     WriteLn ( 'Writing out last connects report file '+ConnectReportFileName );
     Close(ConnectF);
     End;

   If CorrectDL Then MarkLog;

   SortAddressBook;

   if MainReportFileName[0]<>#0 Then
     Begin
     Assign(T,MainReportFileName);
     {$I-} Rewrite ( T );
     {$I+} CheckIOErrorS ( 'Can not create results file: '+MainReportFileName );
     WriteLn ( 'Writing out results file '+MainReportFileName+'...' );

     TotalDial:=0;
     TotalBusy:=0;
     TotalNoCarrier:=0;
     TotalConnect:=0;
     TotalInCalls:=0;
     For i:=1 To NextAddr-1 Do
        With AddrBook^[i] Do
            Begin
            Inc(TotalDial,Busy+Connect+NoCarrier);
            Inc(TotalBusy,Busy);
            Inc(TotalNoCarrier,NoCarrier);
            Inc(TotalConnect,Connect);
            Inc(TotalInCalls,InCalls);
            End;
     If TotalDial=0 Then TotalDial:=1;

     WriteLn(T);
     WriteLn(T,'Binley activity statistic created by -= Bink/+ Spy =- Log Assistant v1.4' );
     WriteLn(T,'Time period: from ', StartDate, ' ', StartTime, '  to ', EndDate, ' ', EndTime );
     WriteLn(T);

     WriteLn(T);
     WriteLn(T,' 1. Station activity graphic. ');
     WriteLn(T,' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ');
     WriteLn(T);

     TotalDays:=0;
     For i:=1 To 24*6 Do
        If TotalDays<Hourly[i].Days Then TotalDays:=Hourly[i].Days;

     For i:=1 To 48 Do
        Begin
        TotalDialing  := 0;
        TotalTransfer := 0;
        TotalBBS      := 0;
        For j:=1 To 3 Do
           If Hourly[Pred(i)*3+j].Days>0 Then
             Begin
             Inc(TotalDialing,Hourly[Pred(i)*3+j].Dialing Div TotalDays );
             Inc(TotalTransfer,Hourly[Pred(i)*3+j].MailTransfer Div TotalDays);
             Inc(TotalBBS,Hourly[Pred(i)*3+j].BBS Div TotalDays);
             End;
        Graph[i].d1 := (16 * TotalDialing) Div 1800;
        Graph[i].d2 := (16 * TotalTransfer) Div 1800;
        Graph[i].d3 := (16 * TotalBBS) Div 1800;
        End;
     For i:=16 DownTo 1 Do
        Begin
        If i=16 Then Write ( T, '100%' )
        Else If i=12 Then Write ( T, ' 75%' )
        Else If i=8 Then Write ( T, ' 50%' )
        Else If i=4 Then Write ( T, ' 25%' )
        Else Write ( T, '    ' );
        For j:=1 To 48 Do
           If i<=Graph[j].d3 Then Write(T,'')
           Else If i<=Graph[j].d2 Then Write(T,'')
           Else If i<=Graph[j].d1 Then Write(T,'')
           Else Write(T,' ');
        If i=15 Then      WriteLn (T,' Legend:  - Dialing')
        Else If i=14 Then WriteLn (T,'          - Files transfer')
        Else If i=13 Then WriteLn (T,'          - BBS')
        Else WriteLn(T);
        End;
     WriteLn ( T, '  0%' );
     WriteLn ( T, '     0 1 2 3 4 5 6 7 8 9 1 1 1 1 1 1 1 1 1 1 2 2 2 2 ' );
     WriteLn ( T, '                         0 1 2 3 4 5 6 7 8 9 0 1 2 3 ' );
     WriteLn(T);

     WriteLn(T,'ͻ' );
     WriteLn(T,' 2. Dial attempt statistics                                                  ' );
     WriteLn(T,'Ķ' );
     WriteLn(T,' Address          Dials       Busy        No carrier  Connect    In.Call' );
     WriteLn(T,'Ķ' );
     For i:=1 To NextAddr-1 Do
        Begin
        With AddrBook^[i] Do
            Begin
            AllDial:=Busy+Connect+NoCarrier;
            If AllDial<>0 Then
              Begin
              Str ( 100.0*Busy/AllDial:6:1, BusyPer);
              Str ( 100.0*NoCarrier/AllDial:6:1, NoCarrierPer);
              Str ( 100.0*Connect/AllDial:6:1, ConnectPer );
              BusyPer:=Trim(BusyPer)+'%';
              ConnectPer:=Trim(ConnectPer)+'%';
              NoCarrierPer:=Trim(NoCarrierPer)+'%';
              WriteLn(T, ' ', Pad(Address,16), '', AllDial:5, 100.0*AllDial/TotalDial:6:1,'%',
                         '', Busy:5, BusyPer:7, '', NoCarrier:5, NoCarrierPer:7, '', Connect:5, ConnectPer:7,
                         '', InCalls:5, '     ', Name );
              End
            Else
              WriteLn(T, ' ', Pad(Address,16), '', 0:5, 0.0:6:1,
                         '%', 0:5, 0:6, '%', 0:5, 0:6, '%', 0:5, 0:6,
                         '%', InCalls:5, '     ', Name );
            End;
        End;
     WriteLn(T,'Ķ' );
     WriteLn(T,' TOTAL: ', NextAddr-1:7,'  ', TotalDial:5, '       ', TotalBusy:5, 100.0*TotalBusy/TotalDial:6:1,'%',
                TotalNoCarrier:5, 100.0*TotalNoCarrier/TotalDial:6:1,'%',
                TotalConnect:5, 100.0*TotalConnect/TotalDial:6:1,'%', TotalInCalls:5, '  ' );
     WriteLn(T,'ͼ' );

     WriteLn(T);
     WriteLn(T,'ͻ' );
     WriteLn(T,' 3. Transfer and modem statistics                                        ' );
     WriteLn(T,'Ķ' );
     WriteLn(T,' Address          Kb sent       Kb received   Average CPS Our online ' );
     WriteLn(T,'Ķ' );
     TotalBSent:=1;
     TotalBReceived:=0;
     TotalCPS:=0;
     TotalSecOnLine:=0;
     For i:=1 To NextAddr-1 Do
        With AddrBook^[i] Do
            Begin
            TotalCPS:= Round ( (1.0*TotalCPS*(TotalBSent+TotalBReceived) + 1.0*AverageCPS*(BytesSent+BytesReceived)) /
                               (TotalBSent+TotalBReceived+BytesSent+BytesReceived+1) );
            Inc(TotalBSent,BytesSent);
            Inc(TotalBReceived,BytesReceived);
            Inc(TotalSecOnLine,SecOnLine);
            End;
     For i:=1 To NextAddr-1 Do
        With AddrBook^[i] Do
            WriteLn(T, ' ', Pad(Address,16), '', BytesSent Div 1024:7, 100.0*BytesSent/(TotalBSent+TotalBReceived+1):6:1,'%',
                       '', BytesReceived Div 1024:7, 100.0*BytesReceived/(TotalBSent+TotalBReceived+1):6:1,'%',
                       '', AverageCPS:11, ' ', (SecOnLine+59) Div 60:6, ' min.    ', Name );
     WriteLn(T,'Ķ' );
     WriteLn(T,' TOTAL: ', NextAddr-1:7,'  ',
                (TotalBSent+1022) Div 1024:7, 100.0*TotalBSent/(TotalBSent+TotalBReceived+1):6:1,'%',
                (TotalBReceived+1023) Div 1024:7, 100.0*TotalBReceived/(TotalBSent+TotalBReceived+1):6:1,'%',
                TotalCPS:11, ' ', (TotalSecOnLine+59) Div 60:6, ' min. ' );
     WriteLn(T,'ͼ' );

     ConnectAll := Connect38400+Connect28800+Connect21600+Connect19200+
                   Connect16800+Connect14400+Connect12000+Connect9600+
                   Connect4800+Connect2400;
     If ConnectAll=0 Then ConnectAll:=1;
     WriteLn(T);
     WriteLn(T,'ͻ' );
     WriteLn(T,' 4. Connection speed summary    ');
     WriteLn(T,'Ķ' );
     WriteLn(T,' Connect 38400+ =', Connect38400:5, ' (', 100.0*Connect38400/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 28800  =', Connect28800:5, ' (', 100.0*Connect28800/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 21600  =', Connect21600:5, ' (', 100.0*Connect21600/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 19200  =', Connect19200:5, ' (', 100.0*Connect19200/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 16800  =', Connect16800:5, ' (', 100.0*Connect16800/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 14400  =', Connect14400:5, ' (', 100.0*Connect14400/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 12000  =', Connect12000:5, ' (', 100.0*Connect12000/ConnectAll:5:1, '%) ' );
     WriteLn(T,' Connect 9600   =',  Connect9600:5, ' (', 100.0*Connect9600/ConnectAll:5:1,  '%) ' );
     WriteLn(T,' Connect 4800   =',  Connect4800:5, ' (', 100.0*Connect4800/ConnectAll:5:1,  '%) ' );
     WriteLn(T,' Connect 2400-  =',  Connect2400:5, ' (', 100.0*Connect2400/ConnectAll:5:1,  '%) ' );
     WriteLn(T,'ͼ' );
     WriteLn(T);

     Close(T);
     End;

   WriteLn ('All done.');

End.

